#
# spec file for package ruby (Version 1.8.7.p249)
#
# Copyright (c) 2011 Lele Forzani <lele@windmill.it>, windmillmedia.
#
# norootforbuild

Name:           ruby19
Version:        1.9.2.p290
Release:        12.1
#
%define pkg_version 1.9.2
%define patch_level p290

# keep in sync with macro file!
%define rb_binary_prefix 1.9
%define rb_arch %(echo %{_target_cpu}-linux | sed -e "s/i686/i586/" -e "s/hppa2.0/hppa/" -e "s/ppc/powerpc/")
# %define rb_ver %(echo %{pkg_version} | sed -e 's/\\\.[0-9]\\\+$//')
%define rb_ver %{pkg_version}

#
%if 0%{?suse_version} == 1100
%define needs_optimization_zero 1
%endif
# from valgrind.spec
%ifarch %ix86 x86_64 ppc ppc64
%define use_valgrind 1
%endif
#

License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Provides:       /usr/lib/ruby
Provides:       ruby19_with_prelude_fix
#
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
# from the old 1.8 spec.
#BuildRequires:  bison gdbm-devel gperf graphviz libjpeg-devel openssl-devel readline-devel tk-devel
BuildRequires:  gdbm-devel ncurses-devel openssl-devel readline-devel tk-devel zlib-devel update-alternatives
%if 0%{?suse_version} > 1010
BuildRequires:  xorg-x11-libX11-devel
%else
BuildRequires:  xorg-x11-devel
%endif
%if 0%{?use_valgrind}
%if 0%{?suse_version} > 1020
BuildRequires:  valgrind-devel
%else
BuildRequires:  valgrind
%endif
%endif
%if 0%{?suse_version} >= 1140
BuildRequires: libyaml-devel
%endif
#
Requires:       rubygems19
#
# Post requires alternatives to install tool alternatives.
Requires(post):   update-alternatives
# Postun requires alternatives to uninstall tool alternatives.
Requires(postun): update-alternatives
#
#
Url:            http://www.ruby-lang.org/
Source:         ftp://ftp.ruby-lang.org/pub/ruby/ruby-%{pkg_version}-%{patch_level}.tar.gz
#
Source3:        site-specific.rb
Source4:        vendor-specific.rb
#
Source5:        ruby19.macros
Source10:       gem_build_cleanup  
Source11:       rubygems.macros
Source12:       builtin_rubygem_defaults.rb
#
Source20:	ruby19-rpmlintrc
#
Patch:          ruby-1.9.1-rc2_gc_64bit_warning.patch
Patch1:         ruby-1.9.2p136_rubygem_prelude.patch
Patch2:         ruby-1.9.2_vendor_specific.patch
Patch10:        rubygems-1.3.7_buildroot.patch
#
Summary:        An Interpreted Object-Oriented Scripting Language
%description
Ruby is an interpreted scripting language for quick and easy
object-oriented programming.  It has many features for processing text
files and performing system management tasks (as in Perl).  It is
simple, straight-forward, and extensible.

* Ruby features:

- Simple Syntax

- *Normal* Object-Oriented features (class, method calls, for
   example)

- *Advanced* Object-Oriented features(Mix-in, Singleton-method, for
   example)

- Operator Overloading

- Exception Handling

- Iterators and Closures

- Garbage Collection

- Dynamic Loading of Object Files (on some architectures)

- Highly Portable (works on many UNIX machines; DOS, Windows, Mac,
BeOS, and more)



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package devel
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        Development files to link against Ruby
Requires:       %{name} = %{version}
%if 0%{?with_bleak_house}
Requires:       ruby_with_bleak_house = %{bleak_house_version}
Provides:       ruby-devel_with_bleak_house = %{bleak_house_version}-%{release}
%endif

%description devel
Development files to link against Ruby.



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package rubygems-builtin
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        Built-in Rubygems
Requires:       %{name} = %{version}
Provides:       rubygems19
Provides:       rubygems19_with_buildroot_patch
Provides:       rubygems19_builtin
Conflicts:      rubygems19_external


%description rubygems-builtin
Built-in Rubygems (to be used as an alternative to external rubygems)



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package tk
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        TCL/TK bindings for Ruby
Requires:       %{name} = %{version}

%description tk
TCL/TK bindings for Ruby



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package doc-ri
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        Ruby Interactive Documentation
Requires:       %{name} = %{version}

%description doc-ri
This package contains the RI docs for ruby



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package doc-html
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        This package contains the HTML docs for ruby

%description doc-html
This package contains the HTML docs for ruby



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package examples
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        Example scripts for ruby
Requires:       %{name} = %{version}

%description examples
Example scripts for ruby



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%package test-suite
License:        BSDL 2-clause
Group:          Development/Languages/Ruby
Summary:        An Interpreted Object-Oriented Scripting Language

%description test-suite
Ruby is an interpreted scripting language for quick and easy
object-oriented programming.  It has many features for processing text
files and performing system management tasks (as in Perl).  It is
simple, straight-forward, and extensible.



Authors:
--------
    Yukihiro Matsumoto <matz@netlab.co.jp>

%prep  
%setup -q -n ruby-%{pkg_version}-%{patch_level}  
#%patch1 -p1
%patch2 -p1
%patch10
# provisional ruby 1.9.2 still has RUBY_VERSION as 1.9.1
sed -i 's/RUBY_VERSION_TEENY 1/RUBY_VERSION_TEENY 2/' version.h

%if 0%{?needs_optimization_zero}
touch -r configure configure.timestamp
perl -p -i.bak -e 's|-O2|-O0|g' configure
diff -urN configure{.bak,} ||:
touch -r configure.timestamp configure
%endif

%build
%if 0%{?needs_optimization_zero}
export CFLAGS="%{optflags}"
export CFLAGS="${CFLAGS//-O2/}"
export CXXFLAGS="$CFLAGS"
export FFLAGS="$CFLAGS"
%endif
%configure \
  --with-soname=ruby19 \
  --enable-shared \
  %if 0%{?use_valgrind}
  --with-valgrind \
  %endif
  --enable-frame-address
make all

%install
%makeinstall
for i in %{buildroot}%{_bindir}/* ; do mv ${i}{,%{rb_binary_prefix}} ; done
for i in %{buildroot}%{_mandir}/man1/* ; do mv "${i}" "${i%%.1}%{rb_binary_prefix}.1" ; done
for i in $(grep -l '#!/usr/bin/ruby' %{buildroot}%{_bindir}/*) ; do
  perl -p -i -e 's|#!/usr/bin/ruby|#!/usr/bin/ruby%{rb_binary_prefix}|' $i ;
done
%{__install} -D -m 0755 %{S:10} %{buildroot}%{_bindir}/gem_build_cleanup1.9
%{__install} -D -m 0644 %{S:5} %{buildroot}/etc/rpm/macros.ruby19
%{__install} -D -m 0644 %{S:11} %{buildroot}/etc/rpm/macros.rubygems 

%{__install} -m 0644 %{S:3}    %{buildroot}%{_libdir}/ruby/site_ruby/%{rb_ver}
%{__install} -m 0644 %{S:4}    %{buildroot}%{_libdir}/ruby/vendor_ruby/%{rb_ver}

# vendor rubygems go here
%{__install} -D -m 0644 %{S:12}    %{buildroot}%{_libdir}/ruby/vendor_ruby/%{rb_ver}/rubygems/defaults.rb
%{__mkdir_p} %{buildroot}%{_libdir}/ruby/vendor_gems/%{rb_ver}
%{__mkdir_p} %{buildroot}%{_libdir}/ruby/vendor_gems/%{rb_ver}/cache
%{__mkdir_p} %{buildroot}%{_libdir}/ruby/vendor_gems/%{rb_ver}/doc
%{__mkdir_p} %{buildroot}%{_libdir}/ruby/vendor_gems/%{rb_ver}/gems
%{__mkdir_p} %{buildroot}%{_libdir}/ruby/vendor_gems/%{rb_ver}/specifications


export NO_BRP_CHECK_RPATH=true

%check
export LD_LIBRARY_PATH="$PWD"
# we know some tests will fail when they do not find a /usr/bin/ruby
make check ||:

%clean
%{__rm} -rf %{buildroot}

%post 
/sbin/ldconfig
update-alternatives --install /usr/bin/ruby ruby /usr/bin/ruby%{rb_binary_prefix} 400 \
  --slave   /usr/share/man/man1/ruby.1.gz ruby.1.gz /usr/share/man/man1/ruby.%{rb_binary_prefix}.gz \
  --slave   /usr/bin/ri ri /usr/bin/ri%{rb_binary_prefix} \
  --slave   /usr/bin/irb irb /usr/bin/irb%{rb_binary_prefix} \
  --slave   /usr/bin/erb erb /usr/bin/erb%{rb_binary_prefix} \
  --slave   /usr/bin/rdoc rdoc /usr/bin/rdoc%{rb_binary_prefix} \
  --slave   /usr/bin/gem gem /usr/bin/gem%{rb_binary_prefix} \
  --slave   /usr/bin/rake rake /usr/bin/rake%{rb_binary_prefix} \
  --slave   /usr/bin/testrb testrb /usr/bin/testrb%{rb_binary_prefix} \
  --slave   /usr/bin/gem_build_cleanup gem_build_cleanup /usr/bin/gem_build_cleanup%{rb_binary_prefix}

%preun
update-alternatives --remove  ruby /usr/bin/ruby1.9

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%config(noreplace) /etc/rpm/macros.ruby19
%dir %{_libdir}/ruby
%dir %{_libdir}/ruby/%{rb_ver}
%{_bindir}/erb%{rb_binary_prefix}
%{_bindir}/irb%{rb_binary_prefix}
%{_bindir}/rake%{rb_binary_prefix}
%{_bindir}/rdoc%{rb_binary_prefix}
%{_bindir}/ri%{rb_binary_prefix}
%{_bindir}/ruby%{rb_binary_prefix}
%{_bindir}/testrb%{rb_binary_prefix}
%{_libdir}/libruby19.so.1.9
%{_libdir}/libruby19.so.1.9.2
%{_libdir}/ruby/
%{_mandir}/man1/ri%{rb_binary_prefix}.1*
%{_mandir}/man1/irb%{rb_binary_prefix}.1*
%{_mandir}/man1/erb%{rb_binary_prefix}.1*
%{_mandir}/man1/rake%{rb_binary_prefix}.1*
%{_mandir}/man1/ruby%{rb_binary_prefix}.1*
%dir %{_libdir}/ruby/site_ruby
%dir %{_libdir}/ruby/site_ruby/%{rb_ver}
%dir %{_libdir}/ruby/vendor_ruby
%dir %{_libdir}/ruby/vendor_ruby/%{rb_ver}
%{_libdir}/ruby/site_ruby/%{rb_ver}/site-specific.rb
%{_libdir}/ruby/vendor_ruby/%{rb_ver}/vendor-specific.rb

%files devel
%defattr(-,root,root,-)
%{_includedir}/ruby-%{pkg_version}
%{_libdir}/libruby19-static.a
%{_libdir}/libruby19.so

%files doc-ri
%defattr(-,root,root,-)
%dir %{_datadir}/ri/
%{_datadir}/ri/%{pkg_version}/

%files rubygems-builtin
%defattr(-,root,root,-)
%{_bindir}/gem%{rb_binary_prefix}
%config(noreplace) /etc/rpm/macros.rubygems
%{_bindir}/gem_build_cleanup%{rb_binary_prefix}
%dir %{_libdir}/ruby/vendor_gems/%{rb_ver}
%dir %{_libdir}/ruby/vendor_gems/%{rb_ver}/cache
%dir %{_libdir}/ruby/vendor_gems/%{rb_ver}/doc
%dir %{_libdir}/ruby/vendor_gems/%{rb_ver}/gems
%dir %{_libdir}/ruby/vendor_gems/%{rb_ver}/specifications
%{_libdir}/ruby/vendor_ruby/%{rb_ver}/rubygems/*.rb

%changelog
